Package net.shibboleth.idp.session.impl

# Class ExtractActiveAuthenticationResults

java.lang.Object
net.shibboleth.shared.component.AbstractInitializableComponent
org.opensaml.profile.action.AbstractProfileAction
org.opensaml.profile.action.AbstractConditionalProfileAction
net.shibboleth.idp.profile.AbstractProfileAction
net.shibboleth.idp.authn.AbstractAuthenticationAction
net.shibboleth.idp.session.impl.ExtractActiveAuthenticationResults

All Implemented Interfaces:
  `Component`, `DestructableComponent`, `InitializableComponent`, `ProfileAction`, `Aware`, `MessageSource`, `MessageSourceAware`, `Action`

public class ExtractActiveAuthenticationResults extends AbstractAuthenticationAction
An authentication action that populates a `AuthenticationContext` with the active `AuthenticationResult` objects found in a `SessionContext` that is a direct child of the `ProfileRequestContext`.

Only results from flows in the "potentialFlows" collection in the `AuthenticationContext` are extracted, which prevents cross-contamination between SPs that have differing rules established for which flows are to be active, because the potentialFlows collection is filtered by that criterion.

If `AuthenticationContext.getHintedName()` is null, then it is populated with the principal name from the session.

Event:
  `EventIds.PROCEED_EVENT_ID`
Precondition:

      ProfileRequestContext.getSubcontext(AuthenticationContext.class, false) != null

Postcondition:
  AuthenticationContext is modified as above.

## Field Summary

Fields
Modifier and Type
Field
Description
`private final org.slf4j.Logger`
`log`
Class logger.
`private boolean`
`populateHintedNameFromSession`
Whether to populate `AuthenticationContext.setHintedName(String)` via the session.
`private IdPSession`
`session`
Session to copy results from.
`private Function<ProfileRequestContext,SessionContext>`
`sessionContextLookupStrategy`
Lookup function for SessionContext.

## Constructor Summary

Constructors
Constructor
Description
`ExtractActiveAuthenticationResults()`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`protected void`
`doExecute(ProfileRequestContext profileRequestContext, AuthenticationContext authenticationContext)`
Performs this authentication action.
`protected boolean`
`doPreExecute(ProfileRequestContext profileRequestContext, AuthenticationContext authenticationContext)`
Performs this authentication action's pre-execute step.
`void`
`setPopulateHintedNameFromSession(boolean flag)`
Set whether to populate `AuthenticationContext.setHintedName(String)` via the session.
`void`
`setSessionContextLookupStrategy(Function<ProfileRequestContext,SessionContext> strategy)`
Set the lookup strategy for the SessionContext to access.

### Methods inherited from class net.shibboleth.idp.authn.AbstractAuthenticationAction

`doExecute, doPreExecute, setAuthenticationContextLookupStrategy`

### Methods inherited from class net.shibboleth.idp.profile.AbstractProfileAction

`doExecute, execute, getBean, getBean, getMessage, getMessage, getMessage, getParameter, getParameter, getProfileContextLookupStrategy, getRequestContext, getResult, setMessageSource, setProfileContextLookupStrategy`

### Methods inherited from class org.opensaml.profile.action.AbstractConditionalProfileAction

`getActivationCondition, setActivationCondition`

### Methods inherited from class org.opensaml.profile.action.AbstractProfileAction

`doPostExecute, doPostExecute, ensureHttpServletRequest, ensureHttpServletResponse, execute, getHttpServletRequest, getHttpServletRequestSupplier, getHttpServletResponse, getHttpServletResponseSupplier, getLogPrefix, isPreExecuteCalled, setHttpServletRequestSupplier, setHttpServletResponseSupplier`

### Methods inherited from class net.shibboleth.shared.component.AbstractInitializableComponent

`checkComponentActive, checkSetterPreconditions, destroy, doDestroy, doInitialize, ifDestroyedThrowDestroyedComponentException, ifInitializedThrowUnmodifiabledComponentException, ifNotInitializedThrowUninitializedComponentException, initialize, isDestroyed, isInitialized`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface net.shibboleth.shared.component.InitializableComponent

`initialize, isInitialized`

## Field Details

### log

@Nonnull private final org.slf4j.Logger log
Class logger.

### sessionContextLookupStrategy

@Nonnull private Function<ProfileRequestContext,SessionContext> sessionContextLookupStrategy
Lookup function for SessionContext.

### populateHintedNameFromSession

private boolean populateHintedNameFromSession
Whether to populate `AuthenticationContext.setHintedName(String)` via the session.

### session

@NonnullBeforeExec private IdPSession session
Session to copy results from.

## Constructor Details

### ExtractActiveAuthenticationResults

public ExtractActiveAuthenticationResults()
Constructor.

## Method Details

### setSessionContextLookupStrategy

public void setSessionContextLookupStrategy(@Nonnull Function<ProfileRequestContext,SessionContext> strategy)
Set the lookup strategy for the SessionContext to access.

Parameters:
  `strategy` - lookup strategy

### setPopulateHintedNameFromSession

public void setPopulateHintedNameFromSession(boolean flag)
Set whether to populate `AuthenticationContext.setHintedName(String)` via the session.

Defaults to true.

Parameters:
  `flag` - flag to set
Since:
  5.2.0

### doPreExecute

protected boolean doPreExecute(@Nonnull ProfileRequestContext profileRequestContext, @Nonnull AuthenticationContext authenticationContext)
Performs this authentication action's pre-execute step. Default implementation just returns true.

Overrides:
  `doPreExecute` in class `AbstractAuthenticationAction`
Parameters:
  `profileRequestContext` - the current IdP profile request context
  `authenticationContext` - the current authentication context
Returns:
  true iff execution should continue

### doExecute

protected void doExecute(@Nonnull ProfileRequestContext profileRequestContext, @Nonnull AuthenticationContext authenticationContext)
Performs this authentication action. Default implementation throws an exception.

Overrides:
  `doExecute` in class `AbstractAuthenticationAction`
Parameters:
  `profileRequestContext` - the current IdP profile request context
  `authenticationContext` - the current authentication context